.\" SPDX-License-Identifier: BSD-2-Clause

.\" Copyright (c) 2022 Alessio Chiapperini

.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.

.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.

.Dd January 21, 2022
.Dt SHUF 1
.Os
.Sh NAME
.Nm shuf
.Nd generate random permutations
.Sh SYNOPSIS
.Nm
.Op Fl h
.Op Fl n Ar count
.Op Fl o Ar outfile
.Op Fl r
.Op Ar file
.Nm
.Op Fl h
.Fl e
.Op Fl n Ar count
.Op Fl o Ar outfile
.Op Fl r
.Op Ar args ...
.Nm
.Op Fl h
.Fl i Ar lo-hi
.Op Fl n Ar count
.Op Fl o Ar outfile
.Op Fl r
.Sh DESCRIPTION
The
.Nm
utility shuffles its input by outputting a random permutation of its input lines.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl e
Treat each command-line operand in
.Ar args
as an input line.
.Pp
Cannot be combined with
.Fl i .
.It Fl h
Print usage information and exit
.It Fl i Ar lo-hi
act as input came from a file containing the numbers in the interval of unsigned integers
.Ar lo-hi
one on each line. The range of possible values for
.Ar lo-hi
is [0, 
.Dv LONG_MAX Ns -1].
.It Fl n Ar count
output at most
.Ar count
lines.
.It Fl o Ar outfile
output lines are printed on
.Ar outfile
instead of standard output.
.It Fl r
repeat values. When this option is turned on, the output no longer contains permutations of the input lines,
instead each output line is randomly chosen from all the input lines. If
.Fl n
is not also given,
.Nm
prints randomly chosen input lines indefinitely.
.El
.Sh "EXIT STATUS"
The
.Nm
utility exits 0 on success, and 1 if an error occurs.
.Sh EXAMPLES
Output 5 random numbers in the range 0-2:
.Dl "shuf -n 5 -r -i 0-2"
.Pp
Flip a coin ten times:
.Dl shuf -e -n 10 -r Heads Tails
.Pp
Select five numbers from 10 to 20:
.Dl shuf -i 10-20 -n 5
.Pp
Shuffle what is provided on standard input and write the output to
.Ar out
.Dl shuf -o out
.Sh BUGS
.Bl -tag -width indent
.It Input lines are limited to BUFSIZ bytes in length.
.It Does not implement the -z and --random-source=file flags present in GNU coreutils' Nm
.It Uses the rand() function from stdlib.h.
.El
.Sh AUTHOR
.An Alessio Chiapperini Aq Mt alessio.chiapperini@\:nullbuffer.com 


